#include <bits/stdc++.h>
using namespace std;

int main(){
    long long n, k; cin >> n >> k;
    long long d[k];
    for(int i = 0; i < k; i++){
        cin >> d[i];
    }
    for(int i = 0; i < k; i++){
        long long trenutniXor = 0;
        if(d[i] == 1){
            trenutniXor = 1;
        }
        else{
            for(int j = 1; j <= sqrt(d[i]); j++){
                if(d[i]%j == 0){
                    if(d[i] != j * j)trenutniXor = trenutniXor ^ j ^ (d[i]/j);
                    else trenutniXor = trenutniXor ^ j;
                }
            }
        }
        cout<<trenutniXor<<endl;
    }

}